package com.yaohun.farmingwar;

import com.yaohun.farmingwar.game.Game;
import com.yaohun.farmingwar.listener.*;
import com.yaohun.farmingwar.liveevent.GiftListener;
import com.yaohun.farmingwar.liveevent.LikeListener;
import com.yaohun.farmingwar.manager.GameManager;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

public class FarmingWar extends JavaPlugin {

    private static FarmingWar instance;
    private static Game game;
    private static GameManager gameManager;

    @Override
    public void onEnable() {
        instance = this;
        gameManager = new GameManager();
        game = new Game();
        Bukkit.getPluginManager().registerEvents(new GiftListener(), this);
        Bukkit.getPluginManager().registerEvents(new LikeListener(gameManager), this);
        Bukkit.getPluginManager().registerEvents(new GamePotect(), this);
        Bukkit.getPluginManager().registerEvents(new GameEffectListener(), this);
        Bukkit.getPluginManager().registerEvents(new GameListener(this), this);
        Bukkit.getPluginManager().registerEvents(new PlayerListener(this), this);
        Bukkit.getPluginManager().registerEvents(new JoinListener(this), this);
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length == 0) {
            sender.sendMessage("/game start - 开始游戏");
            return true;
        }else {
            String subCommand = args[0];
            if (subCommand.equalsIgnoreCase("start")) {
                if (!(sender instanceof Player)) {
                    sender.sendMessage("非玩家无法开始游戏");
                    return true;
                }
                if (game.isStarted()) {
                    sender.sendMessage("游戏已开始");
                    return true;
                }
                game.start();
            }
        }
        return false;
    }

    public static Game getGame() {return game;}
    public static FarmingWar inst() {return instance;}
    public static GameManager getGameManager() {return gameManager;}
}
